'***************************************************************************************************
'* PRIMORTAL XMLTV ?2004 (support @ www.samurize.com)
'***************************************************************************************************
'* VERSION	2.1 - 2004.06.10
'* INSTRUCTIONS/README @ http://www.primortal.com/downloads/samurize/xmltv/
'***************************************************************************************************
'// Global Settings
Public XMLDoc, XMLNode, XMLTVRecordSet, Today, OriginalLocale, CurrentLocale, SamurizeDir
Const XMLTVPath		= "C:\Program Files\XMLTV\"			'/ Path of the XML,XMLTV.EXE and XMLTV.DTD files
SamurizeDir		= CreateObject("WScript.Shell").RegRead("HKEY_CURRENT_USER\Software\Serious Samurize\General\DirPath")

'/ Settings for MyChannels
Const TwentyFourHours	= False						'/ Do you want the shows time in 24 hour format (true|false)
Const LowercaseAMPM	= True						'/ Do you want AM/PM lowercase (true/false).
									'/ (only works if TwentyFourHours = false)
Const ShowstoDisplay	= 1						'/ How many show per-channel to return
Const MissingText		= "(n/a)"						'/ What to display if a field is empty
Const WordWrap		= 55						'/ Number of characters before starting on a new line (no less than 15, 0 to turn off)

									'/ Settings for DownloadTVListing
Const TVListings		= "tv_grab_na_dd"					'/ What area to grab the tv listing from
Const TimeZone		= "MST7MDT"					'/ Your timezone
Const Days2Get		= 2						'/ How many day of programming you want to download
Const XMLTVSwitches	= "--old-chan-id"					'/ Command line switches to pass to XMLTV
									'/ You need '--old -chan-id' if you are using 'tv_grab_na_dd', othewise its not needed

Const DisplayNonErrors	= True						'/ Display only errors (true|false)

'**********************************************************************
'// Testing functions outside of samurize
'   Use to test the function independently outside of samurize.
'	Remember to add the ' to the beginning of the line before use in samurize.

'wscript.echo(MyChannels("","AllChannels"))
'wscript.echo(MyChannels("C43scifi.zap2it.com","MoreShows"))
'wscript.echo(ListChannels())
'wscript.echo(MyShowsProgress("C45toon.zap2it.com"))

'wscript.echo(DownloadTVListing())
'**********************************************************************

Function MyChannels(channel,templatename)
	If Not LoadXMLTV(Channel) Then
		MyChannels = "No listings avaliable"
		Exit Function
	End if
	
	If Channel <> "" Then
		Do While Not XMLTVRecordSet.EOF
			Show = Show & SamurizeTemplate(TemplateName)
			XMLTVRecordSet.MoveNext
			If C = ShowstoDisplay Then Exit Do
			C = C + 1
		Loop		
	Else
		XMLTVRecordSet.Sort = "ChannelNumber ASC"

		Do While Not XMLTVRecordSet.EOF
			Show = Show & SamurizeTemplate(TemplateName)
			XMLTVRecordSet.MoveNext
		Loop
	End If	
	
	MyChannels = show

	XMLTVRecordSet.Close
	Set XMLTVRecordSet = Nothing
End Function

Function MyShowsProgress(Channel)
	If Not LoadXMLTV(Channel) Then
		MyShowsProgress = "No listings avaliable"
		Exit Function
	End If

	XMLTVRecordSet.MoveFirst
	MyShowsProgress = ShowsProgress(XMLTVRecordSet("ShowStart"),XMLTVRecordSet("ShowEnd"),XMLTVRecordSet("ShowDate"))

	XMLTVRecordSet.Close
	Set XMLTVRecordSet = nothing
End Function

Function DownloadTVListing()
	Set WshShell = CreateObject("WScript.Shell")
	Set oFileSys = CreateObject("Scripting.FileSystemObject")
	NonErrors = ""

	FoundCurrentProgramming = False

	for each file in oFileSys.GetFolder(XMLTVPath).Files
		If oFileSys.GetExtensionName(file.Name) = "xml" = True And FormatDateTime(DateAdd("d", days2get - 1, file.DateLastModified),2) > FormatDateTime(Now,2) Then
			If InStr(file.name, "_xmltv") <> 0  then
				If DisplayNonErrors Then NonErrors = "You have a current listing%b"
				FoundCurrentProgramming = True
			End If
		End If
	Next

	If oFileSys.FileExists(XMLTVPath & "\xmltv.exe") Then
		If FoundCurrentProgramming = False Then
			buildshellrun = TimeZone & " " & Chr(34) & xmltvpath & Chr(34) & " " & tvlistings & " " & days2get & " " & XMLTVSwitches
			SR = WshShell.Run(Chr(34) & SamurizeDir & "scripts\gettvxml.cmd"& Chr(34) & " " & buildshellrun ,0,True)
			DownloadTVListing = NonErrors & XMLTVOutput & "%bDone downloading latest schedule"
		Else
			DownloadTVListing = NonErrors 
		End If
	Else
		DownloadTVListing = "Could not find xmltv.exe in%b" & XMLTVPath & "%bPlease makre sure the path is currect."
	End if
	
	'/ Clean up
	Set oFileSys = nothing
	Set oFolder = nothing
	Set oFolders = nothing
	Set oFiles = nothing
End Function

Function ListChannels()
	'// The meat of the program, don't touch anything below unless you know what you are doing
	Set oFileSys = CreateObject("Scripting.FileSystemObject")
	Set oFolder = oFileSys.GetFolder(XMLTVPath)
	Set oFolders = oFolder.SubFolders
	Set oFiles = oFolder.Files
	ListingFound = False

	For Each item in oFiles
		If oFileSys.GetExtensionName(UCase(item.Name)) = "XML" And InStr(Item.name, "_xmltv") > 0 Then
			AC = AC & Left(item.name, InStr(item.name, "_xmltv") -1) & "%b"
			ListingFound = True
		End If
	Next

	If ListingFound then
		ListChannels = AC & "%buse the names above for the%bGetChannelListing() function%bthe names are case-sensitive"
	Else
		ListChannels = "Sorry, couldn't find any listings for your channels"
	End if
End Function

' ### START OF PRIVATE FUNCTIONS ###

Private Function LoadXMLTV(Channel)
	'// DON'T TOUCH any code below unless you know what you are doing
	OriginalLocale = SetLocale("en-us")
	LoadXMLTV = True
	
	Set DictionaryXMLFiles = CreateObject("Scripting.Dictionary")

	Const adVarChar = 200
	Const adDBDate = 133
	Const adDBTimeStamp = 135
	Const adOpenStatic = 3
	Const adUserClient = 3
	Const adVarNumeric = 139
		
	If Minute(Now) => 0 And Minute(Now) < 30 Then
		Min = "00"
	ElseIf Minute(Now) => 30 Then
		Min = "30"
	End if

	Today = FormatDateTime(now,2) & " " & FormatDateTime(Hour(Now) & ":" & Min,4)
	
	If Channel = "" Then
		' Load all xml for current day
		Set oFileSys = CreateObject("Scripting.FileSystemObject")
		Set oFolder = oFileSys.GetFolder(XMLTVPath)
		Set oFolders = oFolder.SubFolders
		Set oFiles = oFolder.Files

		For Each item in oFiles
			If oFileSys.GetExtensionName(UCase(item.Name)) = "XML" And InStr(Item.name, "xmltv") > 0 Then
				XMLFile = XMLTVPath & item.name
				DictionaryXMLFiles.add Left(Item.name,InStr(item.name, "_") -1) & "|"  & CStr(Year(Today)) & CStr(right("0" & Month(Today),2)) & CStr(right("0" & Day(Today),2)), XMLTVPath & item.name
			End If
		Next
		If DictionaryXMLFiles.Count = 0 Then
			LoadXMLTV = False
			Exit Function
		End if
	Else
		DictionaryXMLFiles.add Channel & "|" & CStr(Year(Today)) & CStr(right("0" & Month(Today),2)) & CStr(right("0" & Day(Today),2)), XMLTVPath & Channel & "_xmltv.xml"
	End If

	Set XMLTVRecordSet = CreateObject("ADODB.Recordset")
	XMLTVRecordSet.Cursortype = adOpenStatic
	XMLTVRecordSet.CursorLocation = adUserClient
	XMLTVRecordSet.Fields.Append "ChannelNameNumber", adVarChar, 50
	XMLTVRecordSet.Fields.Append "ChannelNumber", adVarChar, 50
	XMLTVRecordSet.Fields.Append "ShowDate", adDBDate
	XMLTVRecordSet.Fields.Append "ShowStart", adDBTimeStamp
	XMLTVRecordSet.Fields.Append "ShowEnd", adDBTimeStamp
	XMLTVRecordSet.Fields.Append "ShowLength", adVarNumeric, 4
	XMLTVRecordSet.Fields.Append "Title", adVarChar, 100
	XMLTVRecordSet.Fields.Append "Episode", adVarChar, 200
	XMLTVRecordSet.Fields.Append "Description", adVarChar, 500
	XMLTVRecordSet.Fields.Append "Rating", adVarChar, 30
	XMLTVRecordSet.Fields.Append "StarRating", adVarChar, 30
	XMLTVRecordSet.Fields.Append "Category", adVarChar, 50
	XMLTVRecordSet.Fields.Append "NextTitle", adVarChar, 100
	XMLTVRecordSet.Fields.Append "NextEpisode", adVarChar, 200
	XMLTVRecordSet.Fields.Append "NextShowStart", adDBTimeStamp	
	XMLTVRecordSet.Fields.Append "NextShowLength", adVarNumeric, 4
	XMLTVRecordSet.Fields.Append "ShowsProgress", adVarChar, 5
	XMLTVRecordSet.Fields.Append "TimeRemaining", adVarChar, 15

	XMLTVRecordSet.Open
	
	Channels = DictionaryXMLFiles.Keys
	Paths = DictionaryXMLFiles.Items

	For t = 0 To DictionaryXMLFiles.Count -1
		CurrentChannel = Left(Channels(t), InStr(Channels(t), "|") -1)
		XMLFile = Paths(t)

		If Not LoadXML(XMLFile) Then
			LoadXMLTV = False
			Exit Function
		End If

		ShowsAvaliable = ""
		AllLoaded = False
		CurrentDay = False
		NextDayNeeded = False
		ShowMoreShows = False
	
		Set XMLNode = XMLDoc.documentElement.selectSingleNode("./channel[@id='" + CurrentChannel + "']")
	
		If Not IsNull(XMLNode) Then
			Set NodeName = XMLNode.selectSingleNode("display-name")
			Set ChannelShows = XMLDoc.documentElement.selectNodes("./programme[@channel='" + CurrentChannel + "']")
	
			Set ChannelList = XMLDoc.documentElement.selectNodes("channel/display-name") 
				
			For P = 0 To ChannelShows.Length -1
				Set Show = ChannelShows.item(p)

		 		If ShowMoreShows = False Then SC = ShowsToDisplay - 1

				SStart = CDate(Mid(Show.getAttribute("start"),5,2) & "/" & Mid(Show.getAttribute("start"),7,2) & "/" & Left(Show.getAttribute("start"),4) & " " & Mid(Show.getAttribute("start"), 9,2) & ":" & Mid(Show.getAttribute("start"), 11,2) & ":" & Mid(Show.getAttribute("start"), 13,2))
				If Not Isnull(Show.getAttribute("stop")) Then
					SEnd = CDate(Mid(Show.getAttribute("stop"),5,2) & "/" & Mid(Show.getAttribute("stop"),7,2) & "/" & Left(Show.getAttribute("stop"),4) & " " & Mid(Show.getAttribute("stop"), 9,2) & ":" & Mid(Show.getAttribute("stop"), 11,2) & ":" & Mid(Show.getAttribute("stop"), 13,2))
				Else
					If P < ChannelShows.Length -1 Then
						Set ShowNext = ChannelShows.item(p+1)
						SEnd = CDate(Mid(ShowNext.getAttribute("start"),5,2) & "/" & Mid(ShowNext.getAttribute("start"),7,2) & "/" & Left(ShowNext.getAttribute("start"),4) & " " & Mid(ShowNext.getAttribute("start"), 9,2) & ":" & Mid(ShowNext.getAttribute("start"), 11,2) & ":" & Mid(ShowNext.getAttribute("start"), 13,2))
					Else
						SEnd = DateAdd("d", 1, Now)
					End if
				End if
				
				If (FormatDateTime(now, 2) => FormatDateTime(SStart,2) And now >= SStart And now < SEnd) Or ShowMoreShows = True Then
				 	If ShowsToDisplay > 1 Then
				 		If SC <> 0 Then
				 			SC = SC - 1
				 			ShowMoreShows = True
				 		Else
				 			ShowMoreShows = False
				 		End if
		 			End IF

				 	Set Title = Show.selectSingleNode("./title")
					Set Episode = Show.selectSingleNode("./sub-title")
					Set Description = Show.selectSingleNode("./desc")
					Set Rating = Show.selectSingleNode("./rating")
					Set StarRating = Show.selectSingleNode("./star-rating")
					Set Category = Show.selectSingleNode("./Category")
	
					XMLTVRecordSet.AddNew
					
					XMLTVRecordSet("ChannelNameNumber") = ChannelList.item(0).text ' Trim(RegExp(ChannelList.item(0).text,False)) & " " & RegExp(ChannelList.item(0).text,True)
					If ChannelList.Length = 2 Then XMLTVRecordSet("ChannelNumber") = ChannelList.item(1).text
					XMLTVRecordSet("ShowDate") = FormatDateTime(now, 2)
					XMLTVRecordSet("ShowStart") =  FormatDateTime(SStart,4)
					XMLTVRecordSet("ShowEnd") = FormatDateTime(Send,4)
					XMLTVRecordSet("ShowLength") = DateDiff("n", SStart, SEnd)
					
					XMLTVRecordSet("Title") = Title.Text
		
					If Not (Description is Nothing) Then XMLTVRecordSet("Description") = Description.Text
					If Not (Rating is Nothing) Then XMLTVRecordSet("Rating") = Rating.Text
					If Not (StarRating is Nothing) Then XMLTVRecordSet("StarRating") = StarRating.Text	
					If Not (Episode is Nothing) Then XMLTVRecordSet("Episode") = Episode.Text
					If Not (Category is Nothing) Then XMLTVRecordSet("Category") = Category.Text

					If P < ChannelShows.Length -1 Then
						Set Show = ChannelShows.item(p+1)
						SStart = CDate(Mid(Show.getAttribute("start"),5,2) & "/" & Mid(Show.getAttribute("start"),7,2) & "/" & Left(Show.getAttribute("start"),4) & " " & Mid(Show.getAttribute("start"), 9,2) & ":" & Mid(Show.getAttribute("start"), 11,2) & ":" & Mid(Show.getAttribute("start"), 13,2))

						
						XMLTVRecordSet("NextShowStart") = FormatDateTime(SStart, 4)
						
						Set Title = Show.selectSingleNode("./title")
						Set Episode = Show.selectSingleNode("./sub-title")

						If Not (Title Is Nothing) Then XMLTVRecordSet("NextTitle") = Title.Text
						If Not (Episode is Nothing) Then XMLTVRecordSet("NextEpisode") = Episode.Text
					Else
						XMLTVRecordSet("NextShowStart") = FormatDateTime(DateAdd("n", DateDiff("n", SStart, SEnd), FormatDateTime(SStart,4)),4)
					End If

					XMLTVRecordSet("ShowsProgress") = CStr(ShowsProgress(XMLTVRecordSet("ShowStart"),XMLTVRecordSet("ShowEnd"),XMLTVRecordSet("ShowDate"))) & "%"
					If (TimeValue(FormatDateTime(Now,4)) >= TimeValue(XMLTVRecordSet("ShowStart"))) And (TimeValue(FormatDateTime(Now,4)) <= TimeValue(XMLTVRecordSet("ShowEnd"))) And (DateValue(Now) = DateValue(XMLTVRecordSet("ShowDate"))) Then
						XMLTVRecordSet("TimeRemaining") = DateDiff("n", Now,SEnd) & " minutes"
					End If
					XMLTVRecordSet.Update
				End If
			Next
		End If

	Next
		
	If XMLTVRecordSet.RecordCount <> 0 Then
		XMLTVRecordSet.MoveFirst
		LoadXMLTV = True
	Else
		LoadXMLTV = False
	End if
		
End Function

Private Function SamurizeTemplate(TemplateName)
	If CheckForFile(SamurizeDir & "scripts\PrimortalXMLTV_Template.txt") Then
		StartTemplate = False
		EndTemplate = False
		Set oFileSys = CreateObject("Scripting.FileSystemObject")
		set Template = oFileSys.OpenTextFile(SamurizeDir & "scripts\PrimortalXMLTV_Template.txt", 1)
		ReDim BuildOutput(0)
		Do until Template.AtEndOfStream
			CurrentLine = Template.ReadLine
			If (Left(CurrentLine, 2) = "#S" And InStr(UCase(CurrentLine), UCase(TemplateName)) <> 0)  Then
				CurrentLine = Template.ReadLine
				StartTemplate = True
			ElseIf Left(CurrentLine, 2) = "#E" And StartTemplate then
				EndTemplate = True
			End If
			
			If StartTemplate And Not EndTemplate Then
				ReDim Preserve BuildOutput(UBound(BuildOutput) + 1)
				BuildOutput(UBound(BuildOutput)) = CurrentLine
			ElseIf StartTemplate And EndTemplate Then Exit Do
			End If
		Loop
		If Not StartTemplate Then
			ReDim BuildOutput(3)
			BuildOutput(1) = "[Channel]%tab[Title] [Rating:[Rating] Category: [Category]]%b"
			BuildOutput(2) = "[Episode]%b"
			BuildOutput(3) = "%w[Description]"
		End if
	Else
		ReDim BuildOutput(3)
		BuildOutput(1) = "[Channel]%tab[Title] [Rating:[Rating] Category: [Category]]%b"
		BuildOutput(3) = "[Episode]%b"
		BuildOutput(3) = "%w[Description]"
	End If
	
	For L = 1 To UBound(BuildOutput)
		BuildTemp = BuildOutput(L)		
		Build = Build & TemplateFieldReplace(BuildTemp)
	Next
	SamurizeTemplate = Build
End Function

Private Function LoadXML(xfile)
	Set oFileSys = CreateObject("Scripting.FileSystemObject")
	If not oFileSys.FileExists(xfile) Then
		LoadXML = False
	Else
		set xmldoc = CreateObject("Msxml2.DOMDocument.4.0")

		xmlDoc.async = False
		xmlDoc.Load (xfile)
		if xmlDoc.parseError.errorCode <> 0 Then
			LoadXML = False
			ErrorText = ErrorText & " |" & xmldoc.parseError.reason
		Else
			LoadXML = True		
		End If
	End If
	Set oFileSys = Nothing
End Function

Private Function TemplateFieldReplace(line)
	Line = Replace(Line,"[ChannelNumber]", XMLTVRecordSet("ChannelNumber"))
	Line = Replace(Line,"[ChannelName]", XMLTVRecordSet("ChannelNameNumber"))
	Line = Replace(Line,"[ChannelNameNumber]", XMLTVRecordSet("ChannelNameNumber"))
	Line = Replace(Line,"[ShowStart]", TimeConvert(XMLTVRecordSet("ShowStart")))
	Line = Replace(Line,"[ShowEnd]", TimeConvert(XMLTVRecordSet("ShowEnd")))
	Line = Replace(Line,"[Title]", XMLTVRecordSet("Title"))
	Line = Replace(Line,"[Episode]", XMLTVRecordSet("Episode"))
	Line = Replace(Line,"[Description]", XMLTVRecordSet("Description"))
	Line = Replace(Line,"[Rating]", XMLTVRecordSet("Rating"))
	Line = Replace(Line,"[Category]", XMLTVRecordSet("Category"))
	Line = Replace(Line,"[NextShow]", XMLTVRecordSet("NextTitle"))
	Line = Replace(Line,"[NextShowTime]", TimeConvert(XMLTVRecordSet("NextShowStart")))
	Line = Replace(Line,"[NextEpisode]", XMLTVRecordSet("NextEpisode"))
	Line = Replace(Line,"[ShowsProgress]", XMLTVRecordSet("ShowsProgress"))
	Line = Replace(Line,"[TimeRemaining]", XMLTVRecordSet("TimeRemaining"))

	TemplateFieldReplace = Line
End Function

Private Function ShowsProgress(StartTime,EndTime,CurrentDate)
	If (TimeValue(FormatDateTime(Now,4)) >= TimeValue(StartTime)) And (TimeValue(FormatDateTime(Now,4)) <= TimeValue(EndTime)) And DateValue(Now) = DateValue(CurrentDate) Then
		length = (hour(EndTime) * 60 + minute(endtime)) - (hour(startTime) * 60 + minute(starttime))
		delta = (hour(now) * 60 + minute(now)) - (hour(startTime) * 60 + minute(starttime))
		
		prog = 0
		if (length>0) then
			prog = Cint(delta / length * 100)
		end if
		
		ShowsProgress = prog
	Else
		ShowsProgress = 0
	End If
End Function

Private Function TimeConvert(t)
        If Not TwentyFourHours Then
                TimeConvert = Replace(FormatDateTime(TimeValue(t),3),":00 ","")
                If LowercaseAMPM Then
                        If InStr(TimeConvert, "PM") > 0 Then
                                TimeConvert = Replace(TimeConvert, "PM","pm")
                        Else
                                TimeConvert = Replace(TimeConvert, "AM","am")
                        End If
                End If
        Else
                TimeConvert = Replace(FormatDateTime(TimeValue(t),4),":00 ","")
        End If
End Function

Private Function RegExp(strng,number)
	Dim regEx, retVal
	Set regEx = New RegExp
	If Number Then
		patrn = "[0-9]*"
	Else
		'patrn = "[a-zA-Z]+?\s+?"
		patrn = "[a-zA-Z]+\s+"
	End If
	regEx.Global = True
	regEx.IgnoreCase = True
	regEx.Pattern = patrn
	Set Matches = regEx.Execute(strng)
	For Each Match In Matches
		RegExp = RegExp + match.value
	Next
	MsgBox strng & " | " & regexp
End Function

Private Function XMLTVInfo()
	Set oFileSys = CreateObject("Scripting.FileSystemObject")

	If oFileSys.FileExists(xmltvpath & "output.log") Then
		Set ts = oFileSys.OpenTextFile(xmltvpath & "output.log", 1)
		s = ts.ReadAll
		XMLTVInfo = ""
		If RegExpTest("request failed",s) Then
			XMLTVInfo = XMLTVInfo + "Problem downloading new listing%b"
		End If
		
		If RegExpTest("newer release",s) Then
			XMLTVInfo = XMLTVInfo +  "There is a newer version of XMLTV avaliable%b"
		End If
		
		If RegExpTest("noticed station(s) unavailable",s) Or RegExpTest("noticed new station(s) available",s) Then
			XMLTVInfo = XMLTVInfo + "Channel line-up changed, need to run%bXMTLTV " & TVListings & " --configure again"
		End if
		ts.close
	End If
End Function

Private Function WriteToFile(name, whattowrite)
	Set WshShell = CreateObject("WScript.Shell")
	Set oFileSys = CreateObject("Scripting.FileSystemObject")
	set MyFile = oFileSys.OpenTextFile(GetSamurizePath & "scripts\" & name & ".txt",8,True)
	MyFile.Writeline(whattowrite)
	MyFile.Close
End Function

Private Function CheckForFile(file) '/Lets make sure the file exists
	Set oFileSys = CreateObject("Scripting.FileSystemObject")
	If not oFileSys.FileExists(file) Then
		CheckForFile = False
	Else
		CheckForFile = True
	End If
	Set oFileSys = Nothing
End Function